commit db3c687f1a5c60d634be0440047fcf1ba2573f36
Author: freddy77 <freddy77>
Date:   Wed Aug 19 11:47:52 2009 +0000

    handle variant data

diff --git a/ChangeLog b/ChangeLog
index 034e192..752091f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Aug 19 13:48:28 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/data.c src/tds/token.c: handle variant data
+
 Wed Aug 19 11:51:14 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/dblib.c: small improve
 
@@ -1741,4 +1744,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2845 2009/08/19 09:50:37 freddy77 Exp $
+$Id: ChangeLog,v 1.2846 2009/08/19 11:47:52 freddy77 Exp $
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 39ea5eb..3e957dd 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.28 2009/06/12 08:53:49 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.29 2009/08/19 11:47:52 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -180,15 +180,13 @@ main(int argc, char *argv[])
 	Test("DATETIME", "2006-06-09 11:22:44", SQL_C_WCHAR, "23 2006-06-09 11:22:44.000");
 	Test("SMALLDATETIME", "2006-06-12 22:37:21", SQL_C_WCHAR, "19 2006-06-12 22:37:00");
 
-#ifdef ENABLE_DEVELOPING
 	if (db_is_microsoft() && db_version_int() >= 0x08000000u) {
 		Test("SQL_VARIANT", "CAST('123' AS INT)", SQL_C_CHAR, "3 123");
 		Test("SQL_VARIANT", "CAST('ciao' AS VARCHAR(10))", SQL_C_CHAR, "4 ciao");
 		Test("SQL_VARIANT", "CAST('321' AS VARBINARY(10))", SQL_C_CHAR, "6 333231");
 		Test("SQL_VARIANT", "CAST('-123.4' AS FLOAT)", SQL_C_CHAR, "6 -123.4");
-		Test("SQL_VARIANT", "CAST('-123.4' AS NUMERIC(10,2))", SQL_C_CHAR, "6 -123.4");
+		Test("SQL_VARIANT", "CAST('-123.4' AS NUMERIC(10,2))", SQL_C_CHAR, "7 -123.40");
 	}
-#endif
 
 	if (db_is_microsoft() && db_version_int() >= 0x09000000u) {
 		Test("VARCHAR(MAX)", "goodbye!", SQL_C_CHAR, "8 goodbye!");
diff --git a/src/tds/token.c b/src/tds/token.c
index 61dcfb0..39f4b66 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.366 2009/08/18 15:11:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.367 2009/08/19 11:47:52 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1992,7 +1992,6 @@ tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
 static int
 tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 {
-#ifdef ENABLE_DEVELOPING
 	int colsize = tds_get_int(tds), varint;
 	TDS_UCHAR type, info_len;
 	TDSVARIANT *v;
@@ -2026,13 +2025,14 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			TDS_ZERO_FREE(v->data);
 		v->data_len = sizeof(TDS_NUMERIC);
 		num = (TDS_NUMERIC*) calloc(1, sizeof(TDS_NUMERIC));
-		v->data = num;
+		v->data = (TDS_CHAR *) num;
 		num->precision = tds_get_byte(tds);
 		num->scale     = tds_get_byte(tds);
 		colsize -= 2;
 		/* FIXME check prec/scale, don't let server crash us */
 		if (colsize > sizeof(num->array))
 			goto error_type;
+		curcol->column_cur_size = colsize;
 		tds_get_n(tds, num->array, colsize);
 		if (IS_TDS7_PLUS(tds))
 			tds_swap_numeric(num);
@@ -2068,12 +2068,6 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 error_type:
 	tds_get_n(tds, NULL, colsize);
 	return TDS_FAIL;
-#else
-	int colsize = tds_get_int(tds);
-	tds_get_n(tds, NULL, colsize);
-	curcol->column_cur_size = -1;
-	return TDS_SUCCEED;
-#endif
 }
 
 /**

